/* Tabela AJCTPAGAR: Ajuste conta a pagar */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela AJCTPAGAR */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Ajuste conta a pagar,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_FIN_AJCTPAGAR
AFTER DELETE OR INSERT OR UPDATE
ON AJCTPAGAR FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_CDFILLOGOPER VARCHAR2(4);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO         := '0';
   V_CDFILLOGOPER := '';
   IF DELETING THEN
      V_TIPO := '3';

      V_DESC := ' DsAj '      || :OLD.DSAJUSTEPAG          ||
                ' VrAj  '     || TO_CHAR(:OLD.VRAJUSTEPAG) ||
                ' EmprAj '    || :OLD.CDECTBAJPAG          ||
                ' NrLcbAj '   || :OLD.NRLCTBAJPAG          ||
                ' CdClasFin ' || :OLD.CDCLASSFINA          ||
                ' EmprFlux '  || :OLD.CDEMMFAJCNTP         ||
                ' FiliFlux '  || :OLD.CDFIMFAJCNTP         ||
                ' DtMovFlux ' || :OLD.DTMOVFLUXO           ||
                ' IdMovFlux ' || :OLD.IDMOVFLUXO;

      V_ITPESQ       := :OLD.CDFILIAL||:OLD.NRLANCTONF||:OLD.NRSEQVENPAG||:OLD.NRPARCELAPAG||:OLD.DTAJUSTEPAG||:OLD.CDAJUCTPAG;
      V_CDFILLOGOPER := :OLD.CDFILIAL;
   ELSE
      IF UPDATING THEN
         V_ITPESQ       := :OLD.CDFILIAL||:OLD.NRLANCTONF||:OLD.NRSEQVENPAG||:OLD.NRPARCELAPAG||:OLD.DTAJUSTEPAG||:OLD.CDAJUCTPAG;
         V_CDFILLOGOPER := :OLD.CDFILIAL;

            V_TIPO := '2';

            V_DESC := ' DsAj '      || :OLD.DSAJUSTEPAG          ||
                      ' VrAj  '     || TO_CHAR(:OLD.VRAJUSTEPAG) ||
                      ' EmprAj '    || :OLD.CDECTBAJPAG          ||
                      ' NrLcbAj '   || :OLD.NRLCTBAJPAG          ||
                      ' CdClasFin ' || :OLD.CDCLASSFINA          ||
                      ' EmprFlux '  || :OLD.CDEMMFAJCNTP         ||
                      ' FiliFlux '  || :OLD.CDFIMFAJCNTP         ||
                      ' DtMovFlux ' || :OLD.DTMOVFLUXO           ||
                      ' IdMovFlux ' || :OLD.IDMOVFLUXO;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDFILIAL||:NEW.NRLANCTONF||:NEW.NRSEQVENPAG||:NEW.NRPARCELAPAG||:NEW.DTAJUSTEPAG||:NEW.CDAJUCTPAG;
         V_CDFILLOGOPER := :NEW.CDFILIAL;

         V_DESC := ' DsAj '      || :NEW.DSAJUSTEPAG          ||
                   ' VrAj  '     || TO_CHAR(:NEW.VRAJUSTEPAG) ||
                   ' EmprAj '    || :NEW.CDECTBAJPAG          ||
                   ' NrLcbAj '   || :NEW.NRLCTBAJPAG          ||
                   ' CdClasFin ' || :NEW.CDCLASSFINA          ||
                   ' EmprFlux '  || :NEW.CDEMMFAJCNTP         ||
                   ' FiliFlux '  || :NEW.CDFIMFAJCNTP         ||
                   ' DtMovFlux ' || :NEW.DTMOVFLUXO           ||
                   ' IdMovFlux ' || :NEW.IDMOVFLUXO;
      END IF;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);
      IF NOT V_DESC IS NULL THEN
         V_DTOPER := SYSDATE;

         INSERT INTO LOGOPERA
            (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER,
             CDPESQITEM, DSOPERACAO, CDFILLOGOPER, DSENDUSUOPER,
             DSRDMUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
         VALUES
            ('AJCTPAGAR', V_DTOPER, NVL(V_USUARIO, ' '), V_TIPO,
             V_ITPESQ, V_DESC, V_CDFILLOGOPER, V_DSREMOTEADDR,
             V_DSSERVERRDM, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
   END IF;
END;
/